#include "cyfx3i2c.h"
#include "I2C.h"

//static uint8_t  gI2cSlaveAddr = 0;
//static uint32_t gI2cByteAddr = 0;


CyBool_t I2c_Write (uint8_t i2c_slave_address,uint16_t address,uint8_t *wd_buf,uint8_t length)
{
    CyFx3BootErrorCode_t   status;
    CyFx3BootI2cConfig_t   i2cConfig;
    CyFx3BootI2cPreamble_t preamble;


    status = CyFx3BootI2cInit ();
    if (status != CY_FX3_BOOT_SUCCESS)
        return CyFalse;


    i2cConfig.busTimeout = I2C_BUS_TIMEOUT_VALUE;
    i2cConfig.dmaTimeout = I2C_DMA_TIMEOUT_VALUE;
    i2cConfig.isDma      = CyFalse;
    i2cConfig.bitRate    = I2C_FREQUENCY_400khz;
    status = CyFx3BootI2cSetConfig (&i2cConfig);
    if (status != CY_FX3_BOOT_SUCCESS)
        return CyFalse;

    preamble.buffer[0] = i2c_slave_address | I2C_CMD_WRITE;
    preamble.buffer[1] = GET_BYTE1 (address);
    preamble.buffer[2] = GET_BYTE0 (address);
    preamble.length    = 3;
    preamble.ctrlMask  = 0;

    status = CyFx3BootI2cTransmitBytes(&preamble, wd_buf, length, I2C_RETRY_CNT);
    if (status == CY_FX3_BOOT_SUCCESS)
    {
            return CyTrue;
    }

    return CyFalse;
}



CyBool_t I2c_Read (uint8_t i2c_slave_address,uint16_t address,uint8_t *rd_buf,uint8_t length)
{
    CyFx3BootErrorCode_t   status;

    CyFx3BootI2cPreamble_t preamble;




    preamble.buffer[0] = i2c_slave_address | I2C_CMD_WRITE;
    preamble.buffer[1] = GET_BYTE1 (address);
   // preamble.buffer[2] = GET_BYTE0 (address);
    preamble.buffer[2] = i2c_slave_address | I2C_CMD_READ;
    preamble.length    = 3;
    preamble.ctrlMask  = I2C_START_BYTE2;

    status = CyFx3BootI2cReceiveBytes (&preamble, rd_buf, length, I2C_RETRY_CNT);
    if (status == CY_FX3_BOOT_SUCCESS)
    {
            return CyTrue;
    }

    return CyFalse;
}
