/*
 * I2C.h
 *
 *  Created on: 25.03.2021
 *      Author: PalcauM
 */

#ifndef I2C_H_
#define I2C_H_

CyBool_t I2c_Read (uint8_t i2c_slave_address,uint16_t address,uint8_t *rd_buf,uint8_t length);
CyBool_t I2c_Write (uint8_t i2c_slave_address,uint16_t address,uint8_t *wd_buf,uint8_t length);

/* Code to read and boot FX3 firmware from I2C EEPROM. */

#define I2C_BUS_TIMEOUT_VALUE           (0xFFFFFFFFu)
#define I2C_DMA_TIMEOUT_VALUE           (0xFFFFu)
#define I2C_FREQUENCY_400khz            (400000u)
#define I2C_FREQUENCY_100khz            (100000u)

#define I2C_SLAVE_ADDRESS_EEPROM        (0xA0u)
#define I2C_SLAVE_ADDRESS_MAXIM_DES     (0xA4u)
#define I2C_SLAVE_ADDRESS_TI_DES        (0x60u)
#define I2C_CMD_WRITE                   (0)
#define I2C_CMD_READ                    (1)
#define I2C_START_BYTE2                 (0x0004)
#define I2C_RETRY_CNT                   (2)

#define FW_HEADER_SIZE                  (4)
#define SECTION_HEADER_SIZE             (8)

#define I2C_SLAVE_SPACE                 (0x10000)
#define GET_BYTE0(addr)                 ((uint8_t)((addr) & 0xFF))
#define GET_BYTE1(addr)                 ((uint8_t)(((addr) >> 8) & 0xFF))

#endif /* I2C_H_ */
